ConditionalExpression (rhino 1.7.14 API)

org.mozilla.javascript.ast

## Class ConditionalExpression

- java.lang.Object
- - org.mozilla.javascript.Node
  - - org.mozilla.javascript.ast.AstNode
    - - org.mozilla.javascript.ast.ConditionalExpression

- All Implemented Interfaces:
    java.lang.Comparable<AstNode>, java.lang.Iterable<Node>

      public class ConditionalExpression
      extends AstNode

  AST node representing the ternary operator. Node type is `Token.HOOK`.

      ConditionalExpression :
              LogicalORExpression
              LogicalORExpression ? AssignmentExpression
                                  : AssignmentExpression

       ConditionalExpressionNoIn :
              LogicalORExpressionNoIn
              LogicalORExpressionNoIn ? AssignmentExpression
                                      : AssignmentExpressionNoIn

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.mozilla.javascript.ast.AstNode

      `AstNode.DebugPrintVisitor, AstNode.PositionComparator`

    - ### Nested classes/interfaces inherited from class org.mozilla.javascript.Node

      `Node.NodeIterator`

  - ### Field Summary

    - ### Fields inherited from class org.mozilla.javascript.ast.AstNode

      `inlineComment, length, parent, position`

    - ### Fields inherited from class org.mozilla.javascript.Node

      `ARROW_FUNCTION_PROP, ATTRIBUTE_FLAG, BOTH, CASEARRAY_PROP, CATCH_SCOPE_PROP, CONTROL_BLOCK_PROP, DECR_FLAG, DESCENDANTS_FLAG, DESTRUCTURING_ARRAY_LENGTH, DESTRUCTURING_NAMES, DESTRUCTURING_PARAMS, DIRECTCALL_PROP, END_DROPS_OFF, END_RETURNS, END_RETURNS_VALUE, END_UNREACHED, END_YIELDS, EXPRESSION_CLOSURE_PROP, first, FUNCTION_PROP, GENERATOR_END_PROP, INCRDECR_PROP, ISNUMBER_PROP, JSDOC_PROP, LABEL_ID_PROP, last, LAST_PROP, LEFT, lineno, LOCAL_BLOCK_PROP, LOCAL_PROP, MEMBER_TYPE_PROP, NAME_PROP, next, NON_SPECIALCALL, OBJECT_IDS_PROP, PARENTHESIZED_PROP, POST_FLAG, PROPERTY_FLAG, propListHead, REGEXP_PROP, RIGHT, SHORTHAND_PROPERTY_NAME, SKIP_INDEXES_PROP, SPECIALCALL_EVAL, SPECIALCALL_PROP, SPECIALCALL_WITH, TARGETBLOCK_PROP, TEMPLATE_LITERAL_PROP, type, VARIABLE_PROP`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ConditionalExpression()`
    `ConditionalExpression(int pos)`
    `ConditionalExpression(int pos, int len)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `getColonPosition()` Returns position of : token
    `AstNode` | `getFalseExpression()` Returns expression to evaluate if test is false
    `int` | `getQuestionMarkPosition()` Returns position of ? token
    `AstNode` | `getTestExpression()` Returns test expression
    `AstNode` | `getTrueExpression()` Returns expression to evaluate if test is true
    `boolean` | `hasSideEffects()`
    `void` | `setColonPosition(int colonPosition)` Sets position of : token
    `void` | `setFalseExpression(AstNode falseExpression)` Sets expression to evaluate if test is false, and sets its parent to this node.
    `void` | `setQuestionMarkPosition(int questionMarkPosition)` Sets position of ? token
    `void` | `setTestExpression(AstNode testExpression)` Sets test expression, and sets its parent.
    `void` | `setTrueExpression(AstNode trueExpression)` Sets expression to evaluate if test is true, and sets its parent to this node.
    `java.lang.String` | `toSource(int depth)` Emits source code for this node.
    `void` | `visit(NodeVisitor v)` Visits this node, then the test-expression, the true-expression, and the false-expression.

    - ### Methods inherited from class org.mozilla.javascript.ast.AstNode

      `addChild, assertNotNull, codeBug, compareTo, debugPrint, depth, getAbsolutePosition, getAstRoot, getEnclosingFunction, getEnclosingScope, getInlineComment, getLength, getLineno, getParent, getPosition, makeIndent, operatorToString, printList, setBounds, setInlineComment, setLength, setParent, setPosition, setRelative, shortName, toSource`

    - ### Methods inherited from class org.mozilla.javascript.Node

      `addChildAfter, addChildBefore, addChildrenToBack, addChildrenToFront, addChildToBack, addChildToFront, getBigInt, getChildBefore, getDouble, getExistingIntProp, getFirstChild, getIntProp, getJsDoc, getJsDocNode, getLastChild, getLastSibling, getNext, getProp, getScope, getString, getType, hasChildren, hasConsistentReturnUsage, iterator, labelId, labelId, newNumber, newString, newString, newTarget, putIntProp, putProp, removeChild, removeChildren, removeProp, replaceChild, replaceChildAfter, resetTargets, setBigInt, setDouble, setJsDocNode, setLineno, setScope, setString, setType, toString, toStringTree`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.lang.Iterable

      `forEach, spliterator`

- - ### Constructor Detail

    - #### ConditionalExpression

          public ConditionalExpression()

    - #### ConditionalExpression

          public ConditionalExpression(int pos)

    - #### ConditionalExpression

          public ConditionalExpression(int pos,
                                       int len)

  - ### Method Detail

    - #### getTestExpression

          public AstNode getTestExpression()

      Returns test expression

    - #### setTestExpression

          public void setTestExpression(AstNode testExpression)

      Sets test expression, and sets its parent.
      Parameters:
        `testExpression` - test expression
      Throws:
        `java.lang.IllegalArgumentException` - if testExpression is `null`

    - #### getTrueExpression

          public AstNode getTrueExpression()

      Returns expression to evaluate if test is true

    - #### setTrueExpression

          public void setTrueExpression(AstNode trueExpression)

      Sets expression to evaluate if test is true, and sets its parent to this node.
      Parameters:
        `trueExpression` - expression to evaluate if test is true
      Throws:
        `java.lang.IllegalArgumentException` - if expression is `null`

    - #### getFalseExpression

          public AstNode getFalseExpression()

      Returns expression to evaluate if test is false

    - #### setFalseExpression

          public void setFalseExpression(AstNode falseExpression)

      Sets expression to evaluate if test is false, and sets its parent to this node.
      Parameters:
        `falseExpression` - expression to evaluate if test is false
      Throws:
        `java.lang.IllegalArgumentException` - if `falseExpression` is `null`

    - #### getQuestionMarkPosition

          public int getQuestionMarkPosition()

      Returns position of ? token

    - #### setQuestionMarkPosition

          public void setQuestionMarkPosition(int questionMarkPosition)

      Sets position of ? token
      Parameters:
        `questionMarkPosition` - position of ? token

    - #### getColonPosition

          public int getColonPosition()

      Returns position of : token

    - #### setColonPosition

          public void setColonPosition(int colonPosition)

      Sets position of : token
      Parameters:
        `colonPosition` - position of : token

    - #### hasSideEffects

          public boolean hasSideEffects()

      Overrides:
        `hasSideEffects` in class `AstNode`

    - #### toSource

          public java.lang.String toSource(int depth)

      Description copied from class: `AstNode`
      Emits source code for this node. Callee is responsible for calling this function recursively on children, incrementing indent as appropriate.

      Note: if the parser was in error-recovery mode, some AST nodes may have `null` children that are expected to be non-`null` when no errors are present. In this situation, the behavior of the `toSource` method is undefined: `toSource` implementations may assume that the AST node is error-free, since it is intended to be invoked only at runtime after a successful parse.

      Specified by:
        `toSource` in class `AstNode`
      Parameters:
        `depth` - the current recursion depth, typically beginning at 0 when called on the root node.

    - #### visit

          public void visit(NodeVisitor v)

      Visits this node, then the test-expression, the true-expression, and the false-expression.
      Specified by:
        `visit` in class `AstNode`
      Parameters:
        `v` - the object to call with this node and its children